extends TextureRect


class_name MoveTile

@export_enum(
		"tiger",
		"dragon",
		"frog",
		"rabbit",
		"crab",
		"elephant",
		"goose",
		"rooster",
		"monkey",
		"mantis",
		"horse",
		"ox",
		"crane",
		"boar",
		"eel",
		"cobra") var move_name: String
		
var moves: Array

var selectable: bool = false
var selected: bool

var oldModulate: Color

signal move_tile_clicked(moves: Array)

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	texture = load("res://moves/" + move_name + "_up.png")
	moves = Moves.all_moves.get(move_name)
	oldModulate = modulate

#to-do: make selectable only on ones own turn
func _gui_input(event: InputEvent) -> void:
	if event is InputEventMouseButton:
		if event.button_index == MOUSE_BUTTON_LEFT and event.pressed:
			if selectable:
				print("selected")
				move_tile_clicked.emit(moves)
				modulate = Color(.7, .7, 1)


func deselect() -> void:
	selected = false
	modulate = oldModulate


func rotate_texture() -> void:
	flip_v = !flip_v
	flip_h = !flip_h
