extends Node

const SERVER_PORT = 8080
var SERVER_IP = ""
const MAX_CONNECTIONS = 1

signal player_connected(peer_id)
signal player_disconnected(peer_id)
signal server_disconnected


func _ready():
	multiplayer.peer_connected.connect(_on_player_connected)
	multiplayer.peer_disconnected.connect(_on_player_disconnected)
	multiplayer.connected_to_server.connect(_on_connected_ok)
	multiplayer.connection_failed.connect(_on_connected_fail)
	multiplayer.server_disconnected.connect(_on_server_disconnected)


func host():
	print("Hosting")
	var server_peer = ENetMultiplayerPeer.new()
	var error = server_peer.create_server(SERVER_PORT, MAX_CONNECTIONS)
	
	if error:
		return error
	
	multiplayer.multiplayer_peer = server_peer
	

func join():
	print("Joining")
	var client_peer = ENetMultiplayerPeer.new()
	var error = client_peer.create_client(SERVER_IP, SERVER_PORT)
	if error:
		return error
	
	multiplayer.multiplayer_peer = client_peer


func _on_player_connected(peer_id):
	print("player connected")
	player_connected.emit(peer_id)
	

func _on_player_disconnected(peer_id):
	print("player disconnected")
	player_disconnected.emit(peer_id)
	

func _on_connected_ok():
	print("player connected ok")
	var peer_id = multiplayer.get_unique_id()
	player_connected.emit(peer_id)


func _on_connected_fail():
	print("player connected fail")
	multiplayer.multiplayer_peer = null
	

func _on_server_disconnected():
	pass
