extends ColorRect

class_name Square

enum Piece_Type{WHITE_KING, WHITE_PAWN, BLACK_KING, BLACK_PAWN, EMPTY}
var piece: Piece_Type
var normal_color: Color
var row: int
var col: int

signal square_clicked(row: int, col: int, piece: Piece_Type)
signal piece_captured(piece: Piece_Type)


func _gui_input(event: InputEvent) -> void:
	if event is InputEventMouseButton:
		if event.button_index == MOUSE_BUTTON_LEFT and event.pressed:
			print("row: %s, col: %s, piece: %s" % [row, col, piece])
			square_clicked.emit(row, col, piece)


func move_square_in(incoming_square: Square) -> void:
	if not piece == Piece_Type.EMPTY:
		get_child(0).free()
		piece_captured.emit(piece)
	incoming_square.get_child(0).reparent(self)
	get_child(0).position.x = 32
	get_child(0).position.y = 32
	piece = incoming_square.piece
	incoming_square.piece = Piece_Type.EMPTY


func color_match(square: Square) -> bool:
	if (piece == Piece_Type.WHITE_KING or piece == Piece_Type.WHITE_PAWN):
		if (square.piece == Piece_Type.WHITE_KING or square.piece == Piece_Type.WHITE_PAWN):
			return true
		else:
			return false
	elif (piece == Piece_Type.BLACK_KING or piece == Piece_Type.BLACK_PAWN):
		if (square.piece == Piece_Type.BLACK_KING or square.piece == Piece_Type.BLACK_PAWN):
			return true
		else:
			return false
	else:
		return false
